#include <io.h>
#include "x1.h"
#include "x1_psg.h"

/**********************************************************************
	orf
**********************************************************************/

void ssg_io(short reg,short val)
{
	short i;
	outp(0x188,reg); for(i=0; i<32; i++) outp(0x5f,0);
	outp(0x18a,val); for(i=0; i<32; i++) outp(0x5f,0);
}

//......................................................................

short psg_ini_98(void)
{
	outp(0x37,0x06); // SPK-ON
	outp(0x37,0x07); // SPK-OFF

	ssg_io( 7,0xbf); // JoyStickgp Sg[=OFF
	ssg_io(15,0x8f); // JoyStick-1gp
	ssg_io( 8,0); // =0
	ssg_io( 9,0); // =0
	ssg_io(10,0); // =0

	return 0;
}

void psg_end_98(void)
{
	outp(0x37,0x07); // SPK-OFF

	ssg_io( 7,0xbf); // JoyStickgp Sg[=OFF
	ssg_io(15,0x8f); // JoyStick-1gp
	ssg_io( 8,0); // =0
	ssg_io( 9,0); // =0
	ssg_io(10,0); // =0
}

byte psg_sta_98(void)
{
	// WCXeBbN joypad.c  msdos.c 
	// ʂ̏[`
	return inp(0x18a);
}

void psg_reg_98(byte V)
{
	outp(0x188,V);
}

void psg_dat_98(byte V)
{
	word freq;

	// WCXeBbN֘ÃWX^ʈ
	if(     PSG_ADR==0x07) V=0x80|(V&0x3f);
	else if(PSG_ADR==0x0f) V=0x8f;

	outp(0x18a,V);
}

