
struct CRTC {
	byte txt_hl;      // (R00) W  (-1)
	byte txt_disp_hl; // (R01) W  \
	byte txt_sync_x;  // (R02) W  ʒu(-1)
	byte sync_lng_hv; // (R03) W  pX
	byte txt_vl;      // (R04) W  (-1)
	byte v_lst;       // (R05) W  X^
	byte txt_disp_vl; // (R06) W  \
	byte txt_sync_y;  // (R07) W  ʒu
	byte interlace;   // (R08) W  C^[[XAXL[
	byte cur_yl;      // (R09) W  ő僉X^AhX(-1)
	byte cur_y1;      // (R10) W  J[\X^[gX^
	byte cur_y2;      // (R11) W  J[\GhX^
	byte txt_top_h;   // (R12) RW X^[gAhX
	byte txt_top_l;   // (R13) RW X^[gAhX
	byte cur_adr_h;   // (R14) RW J[\AhX
	byte cur_adr_l;   // (R15) RW J[\AhX
	byte pen_adr_h;   // (R16) R  CgyAhX
	byte pen_adr_l;   // (R17) R  CgyAhX

	byte lng_flg; // 40/80 (8255(2) PORT-C D6)
	byte dsp_flg; // ʊǗ  I/O:0x1fd*
};

/***********************************************************************
	txt_hl;      // (R00) W (-1)
	txt_disp_hl; // (R01) W \
	txt_sync_x;  // (R02) W ʒu(-1)
	txt_vl;      // (R04) W (-1)
	txt_disp_vl; // (R06) W \
	txt_sync_y;  // (R07) W ʒu
		Ŏw

	sync_lng_hv; // (R03) W pX
		ʂSrbgM̕𕶎
		ʂSrbgM̕X^

	v_lst;       // (R05) W X^
		c̕\ʒuiG~[gɂ͖֌Wj
		X^Ŏw

	interlace;   // (R08) W C^[[XAXL[
		rbgƂɈӖiwPŒʏ͂Oj
			b7 b6 b5 b4 b3 b2 b1 b0
			C1 C0 D1 D0 ** **  V  S
		C1,C0      D1,D0 DISPTMG    V,S ׽  Ӱ      
			0,0            0,0          	0,0  ڰ          
			0,1 P         0,1 P       	0,1 ڰ ݸ         
			1,0 Q         1,0 Q       	1,0  ڰ          
			1,1 o͂Ȃ   1,1 o͂Ȃ 	1,1 ڰ ݸ & ޵ 

	cur_yl;      // (R09) W ő僉X^AhX
		eLXgPs̃X^|P

	cur_y1;      // (R10) W J[\X^[gX^
	cur_y2;      // (R11) W J[\GhX^
		J[\̌` iwPł͖gpj

	txt_top_h;   // (R12) RW X^[gAhX
	txt_top_l;   // (R13) RW X^[gAhX
		uq`l̕\JnAhX
		uq`l擪̃ItZbgŎw

	cur_adr_h;   // (R14) RW J[\AhX
	cur_adr_l;   // (R15) RW J[\AhX
		J[\\ʒuiwPł͖gpj
		uq`l擪̃ItZbgŎw

	pen_adr_h;   // (R16) R CgyAhX
	pen_adr_l;   // (R17) R CgyAhX
		݂̃CgÿʒuiwPł͖gpj
		uq`l擪̃ItZbgŎw

  --------------------------------------------------------------------

	dsp_flg;  ʊǗ (I/O=1fd*h)

		d0(01) = 0:𑜓x 1:𑜓x
		d1(02) = 0:1׽     1:2׽      <- 0=400ײݥӰ 'd0=1'̎ɗL
		d2(04) = 0:25(20)s 1:12(10)s
		d3(08) = 0:ݸ-0   0:ݸ-1    <- \
		d4(10) = 0:ݸ-0   0:ݸ-1    <- 
		d5(20) = 0:    1:      <- PCG`[h
		d6(40) = 0:8׽CG   1:16׽CG
		d7(80) = 0:\   1:\ <- ްײ (P̎̓OtBbN\)

		X1turboIOCS 0x1fd* ɏo͂l
		[ 0xf8d6 ɕۑĂ

  --------------------------------------------------------------------

	wPł́uWX^̓ǂݍ݁voȂ
	bqsb́ueLXgʁvɍlĐݒ肷
		OtBbNʂ̓eLXgʂƓĕω
	eLXg3000HԒnƃOtBbN
		4000H,4800H,5000H,5800H,6000H,6800H,7000H,7800HԒn
		ǂ̂悤ȐݒɂĂdȂĕ\

***********************************************************************/

extern byte PAL_TBL[16];

extern byte PAL_B;
extern byte PAL_R;
extern byte PAL_G;

extern byte CRT_PLY;

extern word HDISP_CNT; // wPłPC`悷Ԃ̃NbN
extern word VDISP_CNT; // @̐ŕ`悷ׂwP̃C

extern short PCG_MODE;
extern short TXT_MODE; // 0=8׽(x1) 1=16׽(x2)

extern short CRT_H320; // 0=80 1=40 (PȂ牡Q{\)
extern short CRT_V400; // 0=200ײ 1=400ײ 3=200ײ (OȊO͍𑜓x)

extern short CPU_BANK; // bot̃ANZXy[W
extern short CRT_BANK; // bqsb̕\y[W
extern short CRT_UPDT;

extern short FNT_XL;
extern short FNT_YL;
extern short TXT_XL;
extern short TXT_YL;

// ̕ϐ 𑜓xɊ֌WȂ
// 1׽=62.58us=250ð  ׂ
// 𑜓x̎͒l𔼕ɂĂ܂
extern short CRT_YL; // \X^
extern short CRT_VL; // X^
extern short CRT_VS; // V-SYNCʒu

extern word VRAM_TOP; // \Jnʒu
extern word VRAM_STP; // PC̃ItZbg

extern word VTOP_TBL[256]; // PCG-VRAM擪AhX

extern struct CRTC CRTC_REG;

//**********************************************************************

extern struct CRTC L200_40x25;
extern struct CRTC L200_80x25;
extern struct CRTC L200_40x12;
extern struct CRTC L200_80x12;
extern struct CRTC L000_40x20;
extern struct CRTC L000_80x20;
extern struct CRTC L000_40x10;
extern struct CRTC L000_80x10;
extern struct CRTC H200_40x25;
extern struct CRTC H200_80x25;
extern struct CRTC H200_40x12;
extern struct CRTC H200_80x12;
extern struct CRTC H400_40x25;
extern struct CRTC H400_80x25;
extern struct CRTC H400_40x12;
extern struct CRTC H400_80x12;
extern struct CRTC H000_40x20;
extern struct CRTC H000_80x20;

//**********************************************************************

short scrn_set(struct CRTC *crtc);

void crtc_updt(void);

short init_crtc(void);

void x1_crtc_reg(byte V);
void x1_crtc_dat(byte V);

void x1_scrn_w(byte Value);
byte x1_scrn_r(void);

void x1_ply_w(byte Value);
byte x1_ply_r(void);

void x1_palet_w(word Port,byte Value);

